#include <julius/juliuslib.h>

#define SEMAPHOR_ON
#ifdef SEMAPHOR_ON
#include <semaphore.h>
#include <sys/stat.h>
#endif //SEMAPHOR_ON

#ifdef SEMAPHOR_ON
sem_t* sem_sync_result;
char sem_name[256];
#endif //SEMAPHOR_ON

//#define SEMAPHOR_DEBUG_PASS
//#define SEMAPHOR_DEBUG_EFFECT

typedef struct {
  int64_t tv_sec;
  int64_t tv_usec;
} timeval64;

typedef struct {
  int source_id;
  float azimuth;
  float elevation;
  timeval64 time;
} __attribute__((packed)) SourceInfo;

/* mfcnet.c */
#ifdef SEMAPHOR_ON
void seg_begin_wait_semaphor();
void recog_end_post_semaphor();
#endif //SEMAPHOR_ON

/* plugin_module.c */
void plugin_module_setup(Recog *recog, void *data);

/* plugin_output_module.c */
void plugin_decode_output_selection(char *str);
void plugin_send_gram_info(RecogProcess *r);
void plugin_setup_output_msock(Recog *recog, void *data);
